#!/usr/local/bin/ruby1.9.2

require 'optparse'
require 'rubygems'
require 'ruby-debug'

port = 1234
OptionParser.new do |opts|
  opts.banner = "Usage: server.rb [options]"

  opts.on("-p", "--port N", Numeric, "Run verbosely") do |v|
    port = v
  end
end.parse!

require 'socket'

acceptor = Socket.new(Socket::AF_INET, Socket::SOCK_STREAM, 0)
address = Socket.pack_sockaddr_in(port, '')
acceptor.bind(address)
acceptor.listen(10)

puts "listening on localhost:#{port}"

children = []
trap('EXIT') { acceptor.close }
trap('INT') do
  puts "\nkilling children: #{children.inspect}"
  children.each do |child|
    Process.kill 'INT', child
  end
end

3.times do

  child = fork do
            trap('INT') { exit }

            loop do
              socket, addr = acceptor.accept
              addr.getnameinfo.join(':') rescue debugger
              puts "[child #$$] accepted: #{addr.getnameinfo.join(':')}"
              loop do
                command = socket.gets
                break unless command
                data = `#{command} 2>&1`
                socket.puts data.length
                socket.flush
                socket.write data
                socket.flush
                puts "[child #$$] executed: #{command.strip}"
              end
              puts "[child #$$] closed: #{addr.getnameinfo.join(':')}"
              socket.close
            end

            exit
          end
  children << child

end

puts "3 children started: #{children.inspect}"
Process.waitall
